import { session } from 'electron';
import OnHeadersReceivedDetails = Electron.OnHeadersReceivedDetails;

function init(): void {
  // these headers only work on webrequests, file:// protocol is handled via meta tags in index.html
  session.defaultSession.webRequest.onHeadersReceived(
    (details: OnHeadersReceivedDetails, callback: (response: {}) => void) => {
      callback({
        responseHeaders: {
          ...details.responseHeaders,
          'Content-Security-Policy': ["default-src 'none'"],
        },
      });
    }
  );
}

export default { init };
