const path = require('path');

module.exports = {
  entry: {
    bundle: path.resolve(__dirname, 'src/renderer.ts'),
  },
  target: 'electron-renderer',
  output: {
    path: path.resolve(__dirname, 'frontend'),
  },
  module: {
    rules: [
      {
        test: /\.svelte$/,
        loaders: [
          {
            loader: 'svelte-loader',
          },
        ],
      },
      {
        test: /\.ts$/,
        loader: [
          {
            loader: 'ts-loader',
          },
        ],
      },
    ],
  },
  resolve: {
    extensions: ['.js', '.ts'],
    alias: {
      atoms: path.resolve(__dirname, 'src/renderer/components/1-atoms'),
      molecules: path.resolve(__dirname, 'src/renderer/components/2-molecules'),
      services: path.resolve(__dirname, 'src/renderer/services'),
    },
  },
};
